/***************************************************************************
 *                                                                         *
 *   begin        : 5 Dec 2003                                             *
 *   copyright    : (C) 2003 by Samokhvalov Anton <red____hat@mail.ru> :)  *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _Chm_H_
#define _Chm_H_

#include <qstring.h>
#include <qcstring.h>
#include <qregexp.h>
#include <kurl.h>
#include <kio/global.h>
#include <kio/slavebase.h>
#include <qtimer.h>
#include <string>

using namespace std;

class QCString;

namespace chm
{
	class chmfile;
};

class kio_chmProtocol : public KIO::SlaveBase
{
	public:
    	kio_chmProtocol(const QCString &pool_socket, const QCString &app_socket);
	    virtual ~kio_chmProtocol();
	    virtual void get( const KURL& url );
		virtual void listDir( const KURL& url );
		virtual void stat( const KURL& url );
		
	private:
		void createEntry( const QString& name, bool isDir, KIO::UDSEntry& entry );
		void reconnectIfNeeded( const QStringList& path );

	private:
		chm::chmfile* d_file;
		QString d_last_path;
};

#endif
