/***************************************************************************
 *                                                                         *
 *   begin        : 15 Jan 2004                                            *
 *   copyright    : (C) 2003 by Samokhvalov Anton <red____hat@mail.ru> :)  *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __history__h__xvb80c8b
#define __history__h__xvb80c8b

#include <qobject.h>
#include <kurl.h>

#include <vector>

#include <Templates.h>

class History: public QObject
{
		Q_OBJECT
	public:
		History();
		virtual ~History();
		
		void add( const KURL& url );
		void up();
		void back();
		void forward();
		void clear();
		void setEnabled( bool e );
		void emitSignal( bool a, bool b, bool c );
		void emitSignal( );
	
	signals:
		void stateChanged( bool up_, bool back_, bool forward_ );
		void goUp();
		void changeUrl( const KURL& url );
	
	private:
		std::vector< KURL > d_urls;
		int d_current_position;
		bool d_enabled;
		bool d_up;
		bool d_back;
		bool d_forward;
};

#endif
