/***************************************************************************
 *                                                                         *
 *   begin        : 15 Jan 2004                                            *
 *   copyright    : (C) 2003 by Samokhvalov Anton <red____hat@mail.ru> :)  *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __main__widget__h__vblvcn98
#define __main__widget__h__vblvcn98

#include <qsplitter.h>

class QLabel;
class TopicTree;
class HtmlView;
class Container;
class Server;
class History;
class TabbedHtml;
class KActionCollection;
class KTabWidget;
class QToolButton;
class QListViewItem;
class QTextCodec;

class MainView: public QSplitter
{
		Q_OBJECT
		friend class HtmlView;
	public:
#ifndef FOR_KPART
		MainView( Container& cont, QWidget* parent = 0, const char* name = 0 );
#endif
		MainView( const QString& fname, KActionCollection* ac,
			QWidget* parent = 0, const char* name = 0 );
		virtual ~MainView();
	
		virtual void polish();
		
		void up();
		void back();
		void forward();
		void home();
		bool openFile( const QString& fname );
		
		TopicTree* getTopicTree();
	
	private:
		void construct( const QString& fname );
		void setStatusBarMessage( const QString& message );
		
	public slots:
		void slotChangeState( bool up_, bool back_, bool forward_ );
		void slotSetZoom( int percents );
		void slotSetCodec( QTextCodec* codec );
		void slotHideTopicTree( bool toggled );
		
	signals:
		void changeState( bool up, bool back, bool forward );
		void signalSetStatusBarMessage( const QString& message );
		void codecChanged( QTextCodec* );

	private:
		TopicTree* d_topic_tree;
		//HtmlView* d_html_view;
		TabbedHtml* d_html_view;
		QLabel* d_status_bar;
		KActionCollection* d_ac;
		QString d_fname;
};

#endif
