/***************************************************************************
 *                                                                         *
 *   begin        : 15 Jan 2004                                            *
 *   copyright    : (C) 2003 by Samokhvalov Anton <red____hat@mail.ru> :)  *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __tabbed_html__h__xkhZOXCUozxic7t
#define __tabbed_html__h__xkhZOXCUozxic7t

#include <ktabwidget.h>

#include "HtmlView.h"

class MainView;
class KActionCollection;
class QToolButton;

class TabbedHtml: public KTabWidget
{
		Q_OBJECT
	public:
		TabbedHtml( const QString& f_name, KActionCollection* ac,
			QWidget* parent, MainView* parent1, const char* name = 0 );
		virtual ~TabbedHtml();

		void setFileName( const QString& fname );
		void setZoomFactor( int percents );

	private:
		HtmlView* currentView();

	public slots:
		void slotSetUrl( QListViewItem* item );
		void slotSetUrl( const KURL& url );
		void up();
		void back();
		void forward();
	
	private slots:
		void slotClosePage();
		void slotDuplicatePage();
		void slotPrevTab();
		void slotNextTab();
		void slotSetCaption( HtmlView* view, const QString& caption );
		void slotCopy();
		void slotCopyURL();
		void slotSelectAll();
		void slotCurrentTabChanged( QWidget* tab );
		
	private:
		QString d_fname;
		MainView* d_parent;
		KActionCollection* d_ac;
		HtmlView* d_view;
		QToolButton* d_close_page;
		QToolButton* d_new_page;
};

#endif
